<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"] ?: array()) + array("_84718d828" . "d2acc3c366" . "f96b07e841" . "f6a" => base64_decode("YWNsLnNpbXBsZQ" . "=="), "_ef2948c87ef38aab9226e41189b29" . "ca7" => base64_decode("REVMRVRFIEZST00gc2ltc" . "GxlX2FjbCBXSEVSRSBvYm" . "plY3RfY29kZSBlcTpzdHI" . "6Y29kZQ=="), "_dbbe14f5676" . "93a631f8a43b" . "65af917ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmcm9tIG" . "RhdGFiYXNlOiBvYmplY3QgY29kZSBu" . "b3Qgc3BlY2lmaWVk"), "_3cda3f34ada92" . "8e4aa39d4629c5" . "504aa" => base64_decode("aW50On" . "JpZ2h0" . "cw=="), "_c95cbc316178c97697a403f4d" . "9124106" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9NIHNp" . "bXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZXE6" . "c3RyOmNvZGU="), "_a8b22fedb27a11e07" . "f5bb9a7c73608ea" => base64_decode("c3RyKDEwMCk6b2JqZWN0X2Nv" . "ZGU="), "_a7ed4d7408bb" . "99b87a09d89d4" . "212d5de" => base64_decode("c2ltcGxlX2FjbA=" . "="), "_b06968b92" . "68deaf3b38" . "0bd0fe922b" . "453" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY29kZSBlc" . "TpzdHI6Y29kZSBBTkQgdXNlcl9pZD1pbnQ6dWlk"), "_80fc2a45acd0150df87d1fb7" . "28940a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN" . "0X2NvZGUgZXE6c3RyOmNvZGUgQU5EIHVzZXJfaWQ9aW50OnVpZA=="), "_0877a0b48cf424a0de57a453c" . "e95e30c" => base64_decode("aW50O" . "nVzZX" . "JfaWQ" . "="), "_27de5a45db71bf24058769b61b3975" . "a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVjdCBjb2RlIG" . "5vdCBzcGVjaWZpZWQ="), "_938704c4c0169c3804d4bd6aa" . "9941a76" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG9iamVjdCBjb2Rl" . "IG5vdCBzcGVjaWZpZWQ="));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_84718d828d2acc3c366f96" . "b07e841f6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_80fc2a45acd0150df87d1fb7" . "28940a60"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_a7ed4d7408bb99b8" . "7a09d89d4212d5de"], [$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_a8b22fedb27a11e07" . "f5bb9a7c73608ea"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_0877a0b48cf424a0d" . "e57a453ce95e30c"] => $user_id, $GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_3cda3f3" . "4ada928e" . "4aa39d46" . "29c5504a" . "a"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_b06968b" . "9268deaf" . "3b380bd0" . "fe922b45" . "3"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_938704c4c0169c3804" . "d4bd6aa9941a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_c95cbc316178c97697a403f" . "4d9124106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_27de5a45db71bf240" . "58769b61b3975a3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_dbbe14f567693" . "a631f8a43b65af" . "917ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_ef2948c87ef38aab9226e" . "41189b29ca7"], $acl->GetObjectCode());
    }
}